// chiSq1.cpp : implementation file
//

#include "stdafx.h"
#include "math.h"
#include "chiSq1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CchiSq dialog


CchiSq::CchiSq(CWnd* pParent /*=NULL*/)
	: CDialog(CchiSq::IDD, pParent)
{
	//{{AFX_DATA_INIT(CchiSq)
	m_fCHI = 0.0f;
	m_iDF = 0;
	m_fPV = 0.0f;
	//}}AFX_DATA_INIT
}


void CchiSq::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CchiSq)
	DDX_Text(pDX, IDC_CHI, m_fCHI);
	DDX_Text(pDX, IDC_DF, m_iDF);
	DDX_Text(pDX, IDC_PV, m_fPV);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CchiSq, CDialog)
	//{{AFX_MSG_MAP(CchiSq)
	ON_BN_CLICKED(IDC_CALCCHI, OnCalcchi)
	ON_BN_CLICKED(IDC_CALCPV, OnCalcpv)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CchiSq message handlers

int CchiSq::DoModal() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::DoModal();
}

void CchiSq::OnCalcchi() 
{
UpdateData(TRUE);
m_fCHI=CHISQ(m_fPV,m_iDF);	
UpdateData(FALSE);
}

void CchiSq::OnCalcpv() 
{
UpdateData(TRUE);
m_fPV=PVALUE(m_fCHI,m_iDF);	
UpdateData(FALSE);
	
}

float CchiSq::CHISQ(float p, int df)
{
 float v=0.5;
 float dv=0.5;
 float x=0;

 while(dv>1e-6)
 { x=1/v-1; 
   dv=dv/2; 
     if (PVALUE(x,df)>p) { v=v-dv; } else { v=v+dv; } }


 return x;
}

float CchiSq::PVALUE(float x, int df)
{
    float Pi=3.14159265359f;
	float p=exp(-0.5*x);
	if ((df%2)==1) { p=p*sqrt(2*x/Pi); };
    int k=df;
	while (k>=2) { p=p*x/k; k=k-2; };
    float t=p;
	int a=df;
	while(t>0.000001*p) { a=a+2; t=t*x/a; p=p+t; };
    return 1-p;
}
